#include "test.h"
#include <msp430x12x2.h>
#include <string.h>


// ext variable
char state_ext = 1;

unsigned char mask_port_1   = 0x0F;
unsigned char mask_port_2   = 0x07;
unsigned char mask_port_3   = 0x30;

unsigned char state_ext_pin_1   = 100;
unsigned char state_ext_pin_2   = 100;
unsigned char state_ext_pin_3   = 100;

unsigned char state_ext_gnd_1   = 0;
unsigned char state_ext_gnd_2   = 0;
unsigned char state_ext_gnd_3   = 0;

unsigned char state_ext_vcc_1   = 0;
unsigned char state_ext_vcc_2   = 0;
unsigned char state_ext_vcc_3   = 0;


//void DelayN (unsigned long a) { while (--a!=0); }

void DelayN (unsigned long a) { return; }

void Stop(void) {
  //while(1);
}

unsigned char TestEXT(void) {

  unsigned char i;

  //-----------------------------------------------------------------------------------------------------------------
  ////// TEST EXT ////////
  //
  // all as GPIO
  P1SEL = 0x0; P2SEL = 0x0; P3SEL = 0x0; 
  
  //// Test for GND /////-----------------------------------
  // all as input
  P1DIR = 0x0; P2DIR = 0x0; P3DIR = 0x0; 

  // pull up - P5.7 and P4.4
  P2OUT |= BIT5;  // high
  P2DIR |= BIT5;  // output
  
  
  // just simple delay
  DelayN(1000);

  // check for low on port 1
  if(((P1IN)|((unsigned char)(~mask_port_1))) != 0x00FF) { state_ext_gnd_1 = 1; Stop(); return 0; }
  // check for low on port 2
  if(((P2IN)|((unsigned char)(~mask_port_2))) != 0x00FF) { state_ext_gnd_2 = 1; Stop(); return 0; }
  // check for low on port 3
  if(((P3IN)|((unsigned char)(~mask_port_3))) != 0x00FF) { state_ext_gnd_3 = 1; Stop(); return 0; }


  //// Test for VCC /////---------------------------------------
  //
  // all as input
  P1DIR = 0x0; P2DIR = 0x0; P3DIR = 0x0;
  
  // pull up - P5.7 and P4.4
  P2OUT &= ~BIT5;  // high
  P2DIR |= BIT5;  // output

  
  // just simple delay
  DelayN(100);

  // check for high on port 1
  if((P1IN&mask_port_1) != 0x0) { state_ext_vcc_1 = 1; Stop(); return 0; }
  // check for high on port 2
  if((P2IN&mask_port_2) != 0x0) { state_ext_vcc_2 = 1; Stop(); return 0; }
  // check for high on port 3
  if((P3IN&mask_port_3) != 0x0) { state_ext_vcc_3 = 1; Stop(); return 0; }

  
  ///// Running zero ///////-----------------------------------
  //
  ///// for Port1 --------------------
  // all as input
  P1DIR = 0x0; P2DIR = 0x0; P3DIR = 0x0; 
  
  // pull up - P5.7 and P4.4
  P2OUT |= BIT5;  // high
  P2DIR |= BIT5;  // output
  
  // just simple delay
  DelayN(100);

  // loop for port 1
  for(i=0; i<8; i++) {

    // this port is not tested
    if(!((mask_port_1)&(1<<i))) continue;

    P1DIR = (1<<i);
    P1OUT = ~(1<<i);

    // just simple delay
    DelayN(100);

    // check port for any zero
    if(((P1IN)|((unsigned char)(~mask_port_1))) != ((0x00FF)&(~(1<<i))))   { state_ext_pin_1 = i; Stop(); return 0; }
    if(((P2IN)|((unsigned char)(~mask_port_2))) != 0x00FF)                 { state_ext_pin_1 = i; Stop(); return 0; }
    if(((P3IN)|((unsigned char)(~mask_port_3))) != 0x00FF)                 { state_ext_pin_1 = i; Stop(); return 0; }
  }

  ///// for Port2 --------------------
  // all as input
  P1DIR = 0x0; P2DIR = 0x0; P3DIR = 0x0; 

  // pull up - P5.7 and P4.4
  P2OUT |= BIT5;  // high
  P2DIR |= BIT5;  // output

  // just simple delay
  DelayN(100);

  // loop for port 2
  for(i=0; i<8; i++) {

    // this port is not tested
    if(!((mask_port_2)&(1<<i))) continue;

    P2DIR = (1<<i)|BIT5;
    P2OUT = ~(1<<i);

    // just simple delay
    DelayN(100);

    // check port for any zero
    if(((P1IN)|((unsigned char)(~mask_port_1))) != 0x00FF)                 { state_ext_pin_2 = i; Stop(); return 0; }
    if(((P2IN)|((unsigned char)(~mask_port_2))) != ((0x00FF)&(~(1<<i))))   { state_ext_pin_2 = i; Stop(); return 0; }
    if(((P3IN)|((unsigned char)(~mask_port_3))) != 0x00FF)                 { state_ext_pin_2 = i; Stop(); return 0; }
  }


  ///// for Port3 --------------------
  // all as input
  P1DIR = 0x0; P2DIR = 0x0; P3DIR = 0x0; 
  
  // pull up - P5.7 and P4.4
  P2OUT |= BIT5;  // high
  P2DIR |= BIT5;  // output

  // just simple delay
  DelayN(100);

  // loop for port 3
  for(i=0; i<8; i++) {

    // this port is not tested
    if(!((mask_port_3)&(1<<i))) continue;

    P3DIR = (1<<i);
    P3OUT = ~(1<<i);

    // just simple delay
    DelayN(100);

    // check port for any zero
    if(((P1IN)|((unsigned char)(~mask_port_1))) != 0x00FF)                 { state_ext_pin_3 = i; Stop(); return 0; }
    if(((P2IN)|((unsigned char)(~mask_port_2))) != 0x00FF)                 { state_ext_pin_3 = i; Stop(); return 0; }
    if(((P3IN)|((unsigned char)(~mask_port_3))) != ((0x00FF)&(~(1<<i))))   { state_ext_pin_3 = i; Stop(); return 0; }

  }


////// TEST EXT END ////////
//---------------------------------------------------------------------------------------------------------

  return 1;
}


